package nc.pub.filesystem.newui;

import java.awt.event.ActionEvent;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;

import javax.swing.AbstractAction;
import javax.swing.Action;

import org.apache.commons.httpclient.HttpException;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import nc.bs.framework.common.NCLocator;
import nc.bs.framework.common.RuntimeEnv;
import nc.funcnode.ui.action.AbstractNCAction;
import nc.itf.bd.defdoc.IDefdocService;
import nc.itf.th.IThOcrService;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.BeanListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.ui.ml.NCLangRes;
import nc.ui.pub.beans.MessageDialog;
import nc.vo.bd.defdoc.DefdocVO;
import nc.vo.pub.BusinessException;



public class ThOCRAction extends AbstractNCAction{

	/**
	 * OCRʶ
	 */
	private static final long serialVersionUID = -5178574564280732585L;
	private static final String upurl="https://up.mypiaojia.com/api/invoiceApi/file/uploadFileSpilit";
	private static final String inverurl="https://api.mypiaojia.com/api/invoiceApi/invoice/ocr";
	private static final String appId="773676128773832704";
	private static final Long   cid=773676128725336064l;
	private static final String secret="6726dea9883f4f6bb2725ac8750d01de";
	private static final String useid="2108";
	private IUAPQueryBS iuap= (IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	private ThFileContentPanel parentpanel ;
	public ThOCRAction(ThFileContentPanel para){
		parentpanel = para;
		this.putValue(AbstractAction.NAME,"OCRʶ");
		this.putValue(Action.SHORT_DESCRIPTION, "OCRʶ");
	}

	@Override
	public void actionPerformed(ActionEvent actionevent) {
		MessageDialog.showHintDlg(parentpanel, "ʾ","ʼOCRʶ");
		
		String vdef17 =(String) parentpanel.editor_.getBillCardPanel().getHeadItem("vdef17").getValueObject();//id
		String pk_org = (String) parentpanel.editor_.getBillCardPanel().getHeadItem("pk_org").getValueObject();
		String pk_group = (String) parentpanel.editor_.getBillCardPanel().getHeadItem("pk_group").getValueObject();
		String filepath =  RuntimeEnv.getInstance().getNCHome()
			      +File.separator +"uploadfile" + File.separator+ vdef17; // ļ·
		
		List<String> filewjlis=getFileNames(filepath);
		
		 if(null==filewjlis||filewjlis.size()==0){
	        	MessageDialog.showErrorDlg(parentpanel, NCLangRes.getInstance().getStrByID("pc", "FileManageUI-000000")/**/
						,"ϴƱٽOCRʶ");
				return;
	        }
		
		IThOcrService  ocrservice=(IThOcrService) NCLocator.getInstance().lookup(IThOcrService.class.getName());
		
//		IInvoiceOCRMaintain iInvoiceOCRMaintain = (IInvoiceOCRMaintain) NCLocator.getInstance().lookup(IInvoiceOCRMaintain.class.getName());
		
		
		//ȡtoken
		String token="";
		try {
			 token=ocrservice.getToken(appId,cid,secret,useid);
		} catch (HttpException e) {
	//		Logger.error(e.getMessage(), e);
			MessageDialog.showErrorDlg(parentpanel, NCLangRes.getInstance().getStrByID("pc", "FileManageUI-000000")/**/
					,"ȡtoken:\n"+e.getMessage());
			return;
		} catch (IOException e) {
			MessageDialog.showErrorDlg(parentpanel, NCLangRes.getInstance().getStrByID("pc", "FileManageUI-000000")/**/
					,"ȡtoken:\n"+e.getMessage());
			return;
		} catch (BusinessException e) {
			MessageDialog.showErrorDlg(parentpanel, NCLangRes.getInstance().getStrByID("pc", "FileManageUI-000000")/**/
					,"ȡtoken:\n"+e.getMessage());
			return;
		}
		
		MessageDialog.showHintDlg(parentpanel, "ʾ","token:"+token);
		StringBuffer sb=new StringBuffer();
		StringBuffer sb2=new StringBuffer();
		StringBuffer sb3=new StringBuffer();
		for(int i=0;i<filewjlis.size();i++){
			File file=new File(filepath+File.separator+filewjlis.get(i));
			//Ʊϴ
			String idjson="";
			try {
				idjson=ocrservice.uploadInvoice(upurl,token, file);
			} catch (Exception e) {
				MessageDialog.showErrorDlg(parentpanel, NCLangRes.getInstance().getStrByID("pc", "FileManageUI-000000")/**/
						,"Ʊϴ:\n"+e.getMessage());
				return;
			}
			
			sb.append(idjson).append("\n");
			
			//Ʊʶ
			String ocrinvoicejson=ocrservice.ocrIdentification(inverurl, token,idjson);
			sb2.append(ocrinvoicejson).append("\n");
			
            //ʶݱݿ add by pcy
//			JSONObject json =iInvoiceOCRMaintain.startInvoiceOCR(file);
			JSONObject json = JSONObject.parseObject(ocrinvoicejson);
			String checkresult;
			try {
				checkresult = checkJson(json);
				if(checkresult != null){
					MessageDialog.showErrorDlg(parentpanel, NCLangRes.getInstance().getStrByID("pc", "FileManageUI-000000")/**/
							,"ocrУ:\n"+checkresult);
					return;
				}
			} catch (Exception e) {
				// TODO Զɵ catch 
				e.printStackTrace();
			}
			JSONObject data = json.getJSONObject("data");
			JSONArray infos = data.getJSONArray("infos");
			for(int j = 0;j < infos.size();j++){
				JSONObject info = infos.getJSONObject(j).getJSONObject("info");
				String code = info.getString("code");//Ʊ
				JSONArray flist = info.getJSONArray("flist");
				String name = "";
				for(int k = 0;k < flist.size();k++){
					name = flist.getJSONObject(k).getString("name").replace("\"", "");//Ʊ
				}
				String memo = info.getString("number");//Ʊ
				JSONObject comm_info = info.getJSONObject("comm_info");
				JSONObject price = comm_info.getJSONObject("price");
				String amount = price.getString("amount");//˰
				String total = price.getString("total");//˰ϼ
				String dtax = price.getString("dtax");//ɵֿ˰
				JSONObject buyer = comm_info.getJSONObject("buyer");
				String mnecode = buyer.getString("tcode");//˰ʶ
				String name2 = buyer.getString("company");//򷽹˾
				JSONObject payer = comm_info.getJSONObject("payer");
				String name3 = payer.getString("tcode");//۷˰ʶ
				String name4 = payer.getString("company");//򷽹˾
				
				IDefdocService idefservice = NCLocator.getInstance().lookup(IDefdocService.class);
				
				DefdocVO[] updatevos=QryDefdocvoInfo(code);
				
				if(updatevos.length>0){
					//Զ嵵룬޸
					DefdocVO defvo =updatevos[0];
					//ֵ
					defvo.setAttributeValue("name", name);
					defvo.setAttributeValue("memo", memo);
					defvo.setAttributeValue("mnecode", mnecode);
					defvo.setAttributeValue("name2", name2);
					defvo.setAttributeValue("name3", name3);
					defvo.setAttributeValue("name4", name4);
					defvo.setAttributeValue("name6", vdef17);
					defvo.setAttributeValue("shortname", amount);
					defvo.setAttributeValue("shortname2", total);
					defvo.setAttributeValue("shortname3", dtax);
					defvo.setAttributeValue("enablestate", 2);
					try {
						idefservice.updateDefdocs(pk_group,updatevos);
					} catch (BusinessException e1) {
						MessageDialog.showErrorDlg(parentpanel, NCLangRes.getInstance().getStrByID("pc", "FileManageUI-000000")/**/
								,"޸Զ嵵:\n"+e1.getMessage());
						return;
					}
				}else{
					DefdocVO[] vos = new DefdocVO[1];
					DefdocVO defvo = new DefdocVO();
					//ֵ
					defvo.setAttributeValue("code", code);
					defvo.setAttributeValue("name", name);
					defvo.setAttributeValue("memo", memo);
					defvo.setAttributeValue("mnecode", mnecode);
					defvo.setAttributeValue("name2", name2);
					defvo.setAttributeValue("name3", name3);
					defvo.setAttributeValue("name4", name4);
					defvo.setAttributeValue("name6", vdef17);
					defvo.setAttributeValue("pk_defdoclist", QryOCRPk());
					defvo.setAttributeValue("pk_group", pk_group);
				//	defvo.setAttributeValue("pk_org", pk_org);
					defvo.setAttributeValue("pk_org", pk_group);
					defvo.setAttributeValue("datatype", 1);
					defvo.setAttributeValue("enablestate", 2);
					defvo.setAttributeValue("shortname", amount);
					defvo.setAttributeValue("shortname2", total);
					defvo.setAttributeValue("shortname3", dtax);
					vos[0] = defvo;
					try {
				//		idefservice.insertDefdocs(pk_org, vos);
						idefservice.insertDefdocs(pk_group, vos);
					} catch (BusinessException e) {
						// TODO Զɵ catch 
						//ExceptionUtils.wrappBusinessException(e.getMessage());
						MessageDialog.showErrorDlg(parentpanel, NCLangRes.getInstance().getStrByID("pc", "FileManageUI-000000")/**/
									,"Զ嵵:\n"+e.getMessage());
						return;
					}
				}
				

			}
			
		}
		
		MessageDialog.showHintDlg(parentpanel, "ʾ","Ʊϴjson:\n"+sb.toString());
		MessageDialog.showHintDlg(parentpanel, "ʾ","ocrʶjson:\n"+sb2.toString());
//		MessageDialog.showHintDlg(parentpanel, "ʾ","ocrʶYY:\n"+sb3.toString());
		MessageDialog.showHintDlg(parentpanel, "ʾ","ʶɹ");
	}
	

	/**
     * õļ
     *
     * @param path ·
     * @return {@link List}<{@link String}>
     */
    private  List<String> getFileNames(String path) {
        File file = new File(path);
        if (!file.exists()) {
            return null;
        }
        List<String> fileNames = new ArrayList<String>();
        return getFileNames(file, fileNames);
    }

/**
     * õļ
     *
     * @param file      ļ
     * @param fileNames ļ
     * @return {@link List}<{@link String}>
     */
    private  List<String> getFileNames(File file, List<String> fileNames) {
        File[] files = file.listFiles();
        for (File f : files) {
            if (f.isDirectory()) {
                getFileNames(f, fileNames);
            } else {
                fileNames.add(f.getName());
            }
        }
        return fileNames;
    }
    
    private String checkJson(JSONObject json) throws Exception {
		
  		StringBuffer mags = new StringBuffer();
  		Boolean empty = true;
  		
  		JSONObject oprepObjectBs = json.getJSONObject("data");
  		
  		if (oprepObjectBs == null || oprepObjectBs.size() == 0) {
  			return "ֵΪգ";
  		}
  		
  		
  		return null;
  	}
      
      //ѯԶ嵵pk
      private String QryOCRPk(){
      	String sql = "select pk_defdoclist from bd_defdoclist where code='OCRTHNC' and nvl(dr,0)=0";
      	Object object = null;
  		try {
  			object = iuap.executeQuery(sql, new ColumnProcessor());
  		} catch (BusinessException e) {
  			// TODO Զɵ catch 
  			e.printStackTrace();
  		}
  		if (object==null) {
  			return null;
  		}else {
  			return object.toString();
  		}
      }
      
      
      
    @SuppressWarnings("unchecked")
	private DefdocVO[]  QryDefdocvoInfo(String code){
        	String sql = "select * from  bd_defdoc where  nvl(dr, 0) = 0 and pk_defdoclist="
        			+ "(select pk_defdoclist from bd_defdoclist where code='OCRTHNC' and nvl(dr,0)=0) and code='" + code + "' ";
        	ArrayList<Object> arrayvos=null;
        	try {
				arrayvos=(ArrayList<Object>) iuap.executeQuery(sql, new BeanListProcessor(DefdocVO.class));
			} catch (BusinessException e) {
				// TODO Զɵ catch 
				e.printStackTrace();
			}
        	
        	if (arrayvos==null) {
      			return new DefdocVO[0];
      		}else {
      			return arrayvos.toArray(new DefdocVO[0]);
      		}
        	
        } 
      
}
