package nc.impl.th;

import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.UUID;

import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IVOPersistence;

import org.apache.commons.codec.digest.DigestUtils;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpException;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.commons.httpclient.methods.RequestEntity;
import org.apache.commons.httpclient.methods.StringRequestEntity;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import nc.itf.th.IThOcrService;
import nc.pub.toolkits.Toolkits;
import nc.th.redistoken.RedisTokenManager;
import nc.vo.pub.BusinessException;
import nc.vo.th.ocr.OCRInvoiceVO;
import net.sf.json.JSONString;
/**
 * OCRӿʵ
 * @author Administrator
 *
 */
public class ThOcrServiceImpl implements IThOcrService{
	
	private IVOPersistence IVOPersistence = (IVOPersistence) NCLocator.getInstance().lookup(IVOPersistence.class);
	
	public String[] insert(ArrayList<?> arrlist) throws BusinessException {
		return this.IVOPersistence.insertVOList(arrlist);
	}
	
	
	@Override
	/**
	 * ȡtoken
	 */
	public String getToken(String appId,Long cid,String secret,String userid) throws HttpException, IOException, BusinessException {
		
		//redisлȡûtoken
		String userToken = RedisTokenManager.getToken(userid);
		//tokenΪ
		if(Toolkits.isEmpty(userToken)){
			//OCRӿ
			userToken=getOcrToken(appId,cid,secret,userid);
			//浽redisʧЧʱ36000
			RedisTokenManager.setTokenTTL(userid,36000, userToken);
		}
		
		 
		 return userToken;
	}

	
	
	/**
	 * ϴƱ
	 * @throws Exception 
	 */
	public String uploadInvoice(String url,String token,File file) throws Exception {
		String resmsg=httpFilePost(url,token,file);
		String id="";
		if(null!=resmsg&&resmsg.indexOf("uploading")!=-1){
			 JSONObject json = JSONObject.parseObject(resmsg);
			 JSONObject data=json.getJSONObject("data");
			 if(null!=data){
				 id=data.getString("id");
			 }else{
				 String msg=json.getJSONObject("res_base").getString("message");
				 throw new BusinessException(msg);
			 }
			
		}
		
		return resmsg;
	}



	/**
	 * OCRʶ
	 */
	@Override
	public String ocrIdentification(String pathUrl, String token,String data) {
		// TODO Զɵķ
		 JSONObject json = JSONObject.parseObject(data);
		 JSONObject jsonobject = new JSONObject();
         jsonobject.put("image_index", json.getJSONObject("data").getString("id"));
         jsonobject.put("fileTypeStr", json.getJSONObject("data").getString("fileType"));
         jsonobject.put("flag", "13");
         jsonobject.put("is_save", "0");
         jsonobject.put("is_sync", "1");
         jsonobject.put("ocrMap","");
         jsonobject.put("operate_type",0);
		 return doPost(pathUrl,token,jsonobject.toString());
	}
	
	
	/**
	 * OCRʶݱݿ
	 * @throws BusinessException 
	 */
	public void insertOCRdataInfo(ArrayList<OCRInvoiceVO> vos) throws BusinessException {
		insert(vos);
	}
	
	

	public String getOcrToken(String appId,Long cid,String secret,String userid)  throws HttpException, IOException, BusinessException{
    	HttpClient httpClient = new HttpClient();
    	httpClient.getHttpConnectionManager().getParams().setConnectionTimeout(5000);
        httpClient.getHttpConnectionManager().getParams().setSoTimeout(5000);
        PostMethod postMethod = new PostMethod("https://api.mypiaojia.com/api/invoiceApi/token/buildToken");
        postMethod.setRequestHeader("content-type", "application/json");
        postMethod.setRequestHeader("appkey", appId);
        long l = System.currentTimeMillis();
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("role", 1);
        map.put("name", "dmy06");
        map.put("name", "dmy06");
        map.put("userId", userid);//OAûϵûid 2108
        map.put("cid", cid);
        String s1 = JSONObject.toJSONString(map);
        String s2 = s1 + "&time=" + l + "&secret="+secret;
        String newMd5 = DigestUtils.md5Hex(s2);
        String s4 = s1 + "&time=" + l + "&md5=" + newMd5;
        RequestEntity entity = new StringRequestEntity (s4 ,"application/json" ,"UTF-8");
        postMethod.setRequestEntity(entity);
        httpClient.executeMethod(postMethod);
		String responseMsg = postMethod.getResponseBodyAsString().trim();
		//ؽ{"data":"WEAPPe8Ke9pFzz9fbZ3qCcN6itq1zLHCKOgPmXHz6uIg8eOg","actionMsg":{"code":0,"message":"ִгɹ"}}
 //       System.out.println("ؽ"+ responseMsg);

		 JSONObject json = JSONObject.parseObject(responseMsg);
		 String token=json.getString("data");
		 String status=json.getString("status");
		 //tokenֵ־ļ
		 
		 
		 if(null!=status){
			 throw new BusinessException(responseMsg);
		 }
		 
		 return token;
	  }
	
	


	 public  String httpFilePost(String uploadUrl,String token, File file) throws Exception {
		 
		//File file = new File(file);
		 String LINEND = "\r\n";
		 String boundary = UUID.randomUUID().toString();
		 FileInputStream fileInputStream = new FileInputStream(file);
	     URL url = new URL(uploadUrl);
	     HttpURLConnection httpURLConnection = (HttpURLConnection) url.openConnection();
	     httpURLConnection.setDoInput(true);
	     httpURLConnection.setUseCaches(false);
	     httpURLConnection.setDoOutput(true);
	     httpURLConnection.setRequestMethod("POST");
	     httpURLConnection.setRequestProperty("connection", "keep-alive");
	     httpURLConnection.setRequestProperty("Charsert", "UTF-8");
	     httpURLConnection.setRequestProperty("Content-Type", "multipart/form-data; boundary=" + boundary);
	     httpURLConnection.setRequestProperty("token", token);
	     httpURLConnection.setRequestProperty("Accept","*/*");
	     DataOutputStream outStream = new DataOutputStream(httpURLConnection.getOutputStream());
         StringBuilder stringBuilder = new StringBuilder();
         stringBuilder.append("--").append(boundary).append(LINEND);
         stringBuilder.append("Content-Disposition: form-data; name=\"file\"; filename=\"" + file.getName() + LINEND);
         stringBuilder.append("Content-Type: " + HttpURLConnection.guessContentTypeFromName(file.getName()) + LINEND);
         stringBuilder.append("Content-Transfer-Encoding: binary"+ LINEND);
         stringBuilder.append(LINEND);
         outStream.write(stringBuilder.toString().getBytes());
    	 InputStream is = new FileInputStream(file);
    	 byte[] buffer = new byte[1024];
    	 int len = 0;
    	 while ((len = is.read(buffer)) != -1){
    		 outStream.write(buffer, 0, len);
    	 }
    	 is.close();
    	 outStream.write(LINEND.getBytes());
    	 byte[] end_data = ("--" + boundary + "--" + LINEND).getBytes();
    	 outStream.write(end_data);
    	 outStream.flush();
         fileInputStream.close();
         String response = readStream(httpURLConnection.getInputStream());
         outStream.close();
         httpURLConnection.disconnect();    
		 return response;
			
		}
		 
		 
		 private  String readStream(InputStream inputStream) throws IOException {
		        ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
		        byte[] buffer = new byte[1024];
		        int bytesRead;
		        while ((bytesRead = inputStream.read(buffer)) != -1) {
		            outputStream.write(buffer, 0, bytesRead);
		        }
		        byte[] bytes = outputStream.toByteArray();
		        String result = new String(bytes, "UTF-8");
		        outputStream.close();
		        return result;
		    }



		 public  String doPost(String pathUrl, String token,String data){
			OutputStreamWriter out = null;
	        BufferedReader br = null;
	        String result = "";
	        try {
	        	URL url = new URL(pathUrl);
	        	//򿪺url֮
	            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
	            //趨ķΪ"POST"ĬGET
	            //postgetĲ֮ͬpostĲǷURLִ棬Ƿhttpڡ
	            conn.setRequestMethod("POST");
	  
	            //30ӳʱ
	            conn.setConnectTimeout(30000);
	            //30ȡʱ
	            conn.setReadTimeout(30000);
	  
	            // ǷhttpUrlConnectionΪpost󣬲ҪhttpڣҪΪtrue, Ĭfalse;
	            conn.setDoOutput(true);
	            // ǷhttpUrlConnection룬Ĭtrue;
	            conn.setDoInput(true);
	  
	            // Postʹû
	            conn.setUseCaches(false);
	  
	            //ͨõ
	            conn.setRequestProperty("accept", "*/*");
	            conn.setRequestProperty("connection", "Keep-Alive");  //άֳ
	            conn.setRequestProperty("Content-Type", "application/json;charset=utf-8");
	            conn.setRequestProperty("token", token);
	  
	            //ӣurl.openConnection()˵ñҪconnect֮ǰɣ
	            conn.connect();
	  
	            /**
	             * 룬ǵõhttpӿ
	             */
	            //ȡURLConnectionӦ
	            //˴getOutputStreamĽconnect(ͬconnect()ڿвconnect()Ҳ)
	            out = new OutputStreamWriter(conn.getOutputStream(), "UTF-8");
	            //
	            out.write(data);
	            //flushĻ
	            out.flush();
	  
	            /**
	             * Ĵ൱ڣȡõhttpӿں󷵻صĽ
	             */
	            //ȡURLConnectionӦ
	            InputStream is = conn.getInputStream();
	            //һַ
	            br = new BufferedReader(new InputStreamReader(is,"UTF-8"));
	            String str = "";
	            while ((str = br.readLine()) != null){
	                result += str;
	            }
	         //   System.out.println(result);
	            
	           /* JSONObject json = JSONObject.parseObject(result);
	            //ȡҪ
	            JSONObject datajson = json.getJSONObject("data");
	            System.out.println("datajson===="+datajson.toString());
	            JSONArray infosjson = datajson.getJSONArray("infos");
	            System.out.println("infosjson===="+infosjson.toString());
	            
	            for (Object infos : infosjson) {
	            	JSONObject infosObject =(JSONObject)infos;
	                String total=infosObject.getJSONObject("info").getJSONObject("comm_info").getJSONObject("price").getString("total");
	                System.out.println("total===="+total);
	            }*/
	            
	            //ر
	            is.close();
	            //Ͽӣdisconnectڵײtcp socketӿʱжϣڱ߳ʹþͲжϡ
	            conn.disconnect();
	        }catch (Exception e) {
	            e.printStackTrace();
	        }finally {
	            try {
	                if (out != null){
	                    out.close();
	                }
	                if (br != null){
	                    br.close();
	                }
	            } catch (IOException e) {
	                e.printStackTrace();
	            }
	        }
			return result;
		 }
	
}
