package nc.pub.toolkits;

import java.text.SimpleDateFormat;
import java.util.Collection;
import java.util.Date;
import java.util.Dictionary;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang.StringUtils;

import nc.bs.framework.common.NCLocator;
import nc.itf.bd.currtype.ICurrtypeQuery;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uapecpub.reference.uap.para.SysParaInitQuery;
import nc.vo.bd.currtype.CurrtypeVO;
import nc.vo.bd.material.measdoc.MeasdocVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pubapp.pattern.data.ValueUtils;

public class Toolkits {
	/**
	 * : 鴫ĲǷΪա valueΪStringvalue.length()Ϊ0true
	 * valueΪObject[]value.lengthΪ0true
	 * valueΪCollectionvalue.size()Ϊ0true
	 * valueΪDictionaryvalue.size()Ϊ0true
	 * valueΪMapvalue.size()Ϊ0true 򷵻false
	 * 
	 * @param value
	 *            ֵ
	 * @returno
	 * @return boolean ֵΪnulltrue
	 */
	@SuppressWarnings("rawtypes")
	public static boolean isEmpty(Object value) {
		if (value == null) {
			return true;
		}
		if ((value instanceof String)
				&& (((String) value).trim().length() <= 0)) {
			return true;
		}
		if ((value instanceof Object[]) && (((Object[]) value).length <= 0)) {
			return true;
		}
		// жеֵǷȫΪnull.
		if (value instanceof Object[]) {
			Object[] t = (Object[]) value;
			for (int i = 0; i < t.length; i++) {
				if (t[i] != null) {
					return false;
				}
			}
			return true;
		}
		if ((value instanceof Collection) && ((Collection) value).size() <= 0) {
			return true;
		}
		if ((value instanceof Dictionary) && ((Dictionary) value).size() <= 0) {
			return true;
		}
		if ((value instanceof Map) && ((Map) value).size() <= 0) {
			return true;
		}
		return false;
	}

	/**************************************************
	 * : ȥʽõĿո : strOldString ǰıʽ ֵ: ıʽ
	 ****************************************************/
	public String completeTrim(String strOldString) {
		char chrString[];
		int length = strOldString.length();
		chrString = new char[length];

		int iStartPos = 0;

		for (int i = 0; i < length; i++) {
			if (strOldString.charAt(i) != ' ')
				chrString[iStartPos++] = strOldString.charAt(i);
		}

		String strNewString = new String(chrString);
		strNewString = strNewString.substring(0, iStartPos);
		return strNewString;
	}

	/**
	 * :תintΪList
	 * 
	 * @param iarray
	 * @return
	 * @return:List
	 */
	@SuppressWarnings("rawtypes")
	public static LinkedList toList(int[] iarray) {
		LinkedList<Integer> list = new LinkedList<Integer>();
		for (int i = 0; i < iarray.length; i++) {
			list.add(new Integer(iarray[i]));
		}
		return list;
	}

	/**
	 * ܣСvalue ȡNλС
	 * 
	 * @param value
	 *            С
	 * @param n
	 *            Сλ
	 * @return
	 */
	public static UFDouble getUfdoubleNRound(UFDouble value, int n) {
		value = new UFDouble(value).setScale(n, UFDouble.ROUND_HALF_UP);
		// value = new UFDouble(value.doubleValue(), n);
		return value;
	}

	/**
	 * ܣСvalue ȡNλСֱӽȡ
	 * 
	 * @param value
	 *            С
	 * @param n
	 *            Сλ
	 * @return
	 */
	public static UFDouble getUFDoubleNRoundDOWN(UFDouble value, int n) {
		value = new UFDouble(value).setScale(n, UFDouble.ROUND_DOWN);
		return value;
	}

	/**
	 * : תListΪint
	 * 
	 * @param list
	 * @return
	 * @return:int[]
	 */
	@SuppressWarnings("rawtypes")
	public static int[] toArray(List list) {
		Object[] arr1 = list.toArray();
		int[] arr2 = new int[list.size()];
		for (int i = 0; i < arr1.length; i++) {
			arr2[i] = ((Integer) arr1[i]).intValue();
		}
		return arr2;
	}

	/**
	 * һStringɴַ,ڴinSQLʹ :('111','222','333','')
	 * 
	 * @param array
	 * @return
	 */
	public static String combinArrayToString(String[] array) {
		if (isEmpty(array)) {
			return "('')";
		}
		StringBuffer str = new StringBuffer("('");
		for (int i = 0; i < array.length; i++) {
			str.append(array[i]);
			str.append("','");
		}
		str.append("')");
		return str.toString();
	}

	/**
	 * һStringɴַ,ڴinSQLʹ :'111','222','333',''
	 * 
	 * @param array
	 * @return
	 */
	public static String combinArrayToString2(String[] array) {

		StringBuffer str = new StringBuffer("");
		for (int i = 0; i < array.length; i++) {
			str.append("'");
			str.append(array[i]);
			str.append("',");
		}
		str.append("''");
		return str.toString();
	}

	/**
	 * һStringɴַ,ڴinSQLʹ :'111','222','333',''
	 * 
	 * @param array
	 * @return
	 */
	public static String combinArrayToString3(String[] pkvaluses) {
		String str = "'";
		if (pkvaluses != null) {
			for (int i = 0; i < pkvaluses.length; i++) {
				if (i == pkvaluses.length - 1) {
					str += pkvaluses[i] + "'";
				} else {
					str += pkvaluses[i] + "','";
				}
			}
			return str;
		} else {
			return null;
		}
	}

	/**
	 * : 滻ַ
	 * 
	 * @param str_par
	 *            ԭʼַ
	 * @param old_item
	 *            滻ַ
	 * @param new_item
	 *            滻ַ
	 * @return
	 * @return:String
	 */
	public static synchronized String replaceAll(String str_par,
			String old_item, String new_item) {
		String str_return = "";
		String str_remain = str_par;
		boolean bo_1 = true;
		while (bo_1) {
			int li_pos = str_remain.indexOf(old_item);
			if (li_pos < 0) {
				break;
			} // Ҳ,򷵻
			String str_prefix = str_remain.substring(0, li_pos);
			str_return = str_return + str_prefix + new_item; // ַԭǰ
			str_remain = str_remain.substring(li_pos + old_item.length(),
					str_remain.length());
		}
		str_return = str_return + str_remain; // ʣļ
		return str_return;
	}

	/**
	 * ϼ
	 * 
	 * @param value
	 * @return
	 */
	public static double total(double[] value) {
		double j = 0;
		for (int i = 0; i < value.length; i++) {
			j = j + value[i];
		}
		return j;
	}

	/**
	 * : ȽַĴС,trueʾǰ
	 * 
	 * @param String
	 *            sa,String sbҪȽϵַ
	 * @return boolean
	 */
	public static boolean compareStr(String sa, String sb) {
		boolean flag = false;
		int i = sa.compareTo(sb);
		if (i < 0) {
			flag = true;
			return flag;
		}
		return flag;
	}

	/**
	 * : ȽֵĴС,trueʾǰ
	 * 
	 * @param String
	 *            sa,String sbҪȽϵַ
	 * @return boolean
	 */
	public static boolean compareDou(UFDouble sa, UFDouble sb) {
		boolean flag = false;
		int i = sa.compareTo(sb);
		if (i < 0) {
			flag = true;
			return flag;
		}
		return flag;
	}

	// "1"ת1ʱ±TOBIG[1]ǶӦ
	private static final String[] TOBIG = new String[] { "", "Ҽ", "", "",
			"", "", "½", "", "", "" };
	// ǵλӵ͵ߵ
	private static final String POS[] = new String[] { "", "ʰ", "", "Ǫ", "",
			"ʰ", "", "Ǫ", "", "ʰ", "", "Ǫ", "", "ʰ", "", "Ǫ", "" };

	/**
	 * תɴд
	 * 
	 * @param number
	 *            java.lang.string
	 * @autor shipeng
	 * @return java.lang.String
	 */
	public static String getCapital(String number) {
		String capital;
		int len_zs = number.indexOf("."); // 
		if (len_zs < 0) {
			capital = getCapitalOfInt(number) + "";// .concat("");
		} else {
			int len_xs = number.substring(len_zs).length(); // С
			capital = getCapitalOfInt(number.substring(0, len_zs)).concat("")
					.concat(getCapitalOfFloat(number.substring(len_zs + 1,
							len_zs + len_xs)));
		}
		return capital;
	}

	/**
	 * תɴд
	 * 
	 * @return java.lang.String
	 * */
	public static String getCapitalOfInt(String str) {
		String newStr = "";
		for (int i = 0, j = str.length(); i < j; i++) {
			String s = str.substring(j - i - 1, j - i);
			newStr = TOBIG[Integer.parseInt(s)].concat(POS[i]) + newStr;
		}
		newStr = newStr.replace("Ǫ", "");
		newStr = newStr.replace("", "");
		newStr = newStr.replace("ʰ", "");
		newStr = newStr.replace("", "");
		for (int i = 0; i < 8; i++)
			newStr = newStr.replace("", "");
		newStr = newStr.replace("Ǫ", "Ǫ");
		newStr = newStr.replace("", "");
		newStr = newStr.replace("ʰ", "ʰ");
		newStr = newStr.replace("", "");
		newStr = newStr.replace("", "");
		if (newStr.endsWith(""))
			newStr = newStr.substring(0, newStr.length() - 1);
		return newStr;
	}

	/**
	 * Сתɴд
	 * 
	 * @return java.lang.String
	 * */
	public static String getCapitalOfFloat(String str) {
		String newStr = "";
		for (int i = 0, j = str.length(); i < j; i++) {
			String s = str.substring(j - i - 1, j - i);
			newStr = TOBIG[Integer.parseInt(s)] + newStr;
		}
		return newStr;
	}

	public static UFDate getUFDate(Object obj) {
		if (!Toolkits.isEmpty(obj)) {
			try {
				return new UFDate(obj.toString().trim());
			} catch (Exception e) {
				return null;
			}
		} else {
			return null;
		}
	}

	public static UFDouble getUFDouble(Object obj) {
		if (!Toolkits.isEmpty(obj)) {
			try {
				return new UFDouble(obj.toString().trim());
			} catch (Exception e) {
				return new UFDouble(0);
			}
		} else {
			return new UFDouble(0);
		}
	}

	public static UFBoolean getUFBoolean(Object obj) {
		if (!Toolkits.isEmpty(obj)) {
			try {
				return new UFBoolean(obj.toString().trim());
			} catch (Exception e) {
				return UFBoolean.FALSE;
			}
		} else {
			return UFBoolean.FALSE;
		}
	}

	public static UFDouble getUFDouble(String obj) {
		if (!Toolkits.isEmpty(obj)) {
			try {
				return new UFDouble(obj.trim());
			} catch (Exception e) {
				return new UFDouble(0);
			}
		} else {
			return new UFDouble(0);
		}
	}

	public static UFDouble getUFDouble(UFDouble ufd) {
		if (!Toolkits.isEmpty(ufd)) {
			try {
				return ufd;
			} catch (Exception e) {
				return new UFDouble(0);
			}
		} else {
			return new UFDouble(0);
		}
	}

	public static Integer getInteger(Object obj) {
		if (!Toolkits.isEmpty(obj)) {
			try {
				return Integer.parseInt(obj.toString().trim());
			} catch (Exception e) {
				return new Integer(0);
			}
		} else {
			return new Integer(0);
		}
	}

	public static Integer getInteger(String obj) {
		if (!Toolkits.isEmpty(obj)) {
			try {
				return Integer.parseInt(obj.trim());
			} catch (Exception e) {
				return new Integer(0);
			}
		} else {
			return new Integer(0);
		}
	}

	public static String getString(String obj) {
		if (!Toolkits.isEmpty(obj)) {
			try {
				return obj == null ? "" : obj.trim();
			} catch (Exception e) {
				return "";
			}
		} else {
			return "";
		}
	}

	public static String getString(Object obj) {
		if (!Toolkits.isEmpty(obj)) {
			try {
				return obj == null ? "" : obj.toString().trim();
			} catch (Exception e) {
				return "";
			}
		} else {
			return "";
		}
	}

	/**
	 * 
	 * @Title: cutZero
	 * @Description: ȥС0
	 * @date 2013-8-28 06:04:11
	 * @return String 
	 * @throws
	 */
	public static String cutZero(String v) {
		if (v.indexOf(".") > -1) {
			while (true) {
				if (v.lastIndexOf("0") == (v.length() - 1)) {
					v = v.substring(0, v.lastIndexOf("0"));
				} else {
					break;
				}
			}
			if (v.lastIndexOf(".") == (v.length() - 1)) {
				v = v.substring(0, v.lastIndexOf("."));
			}
		}
		return v;
	}

	/**
	 * <b>function:</b> oracle sql inӾУwhere id in (1, 2, ..., 1000,
	 * 1001)Ӿг1000ͻᱨ ҪoracleơҪ⣬ where id (1,
	 * 2, ..., 1000) or id (1001, ...)
	 * 
	 * @createDate 2013-01-1502:36:03
	 * @param ids
	 *            inеļ϶
	 * @param count
	 *            inгֵ
	 * @param field
	 *            inӦݿѯֶ
	 * @return  field in (...) or field in (...) ַ
	 */
	public static String getOracleSQLIn(List<String> ids, int count,
			String field) {
		if (ids != null && ids.size() > 0) {
			count = Math.min(count, 1000);
			int len = ids.size();
			int size = len % count;
			if (size == 0) {
				size = len / count;
			} else {
				size = (len / count) + 1;
			}
			StringBuilder builder = new StringBuilder();
			for (int i = 0; i < size; i++) {
				int fromIndex = i * count;
				int toIndex = Math.min(fromIndex + count, len);
				String productId = StringUtils.defaultIfEmpty(StringUtils.join(
						ids.subList(fromIndex, toIndex).iterator(), "','"), "");
				if (i != 0) {
					builder.append(" or ");
				}
				builder.append(field).append(" in ('").append(productId)
						.append("')");
			}
			String result = " ("
					+ StringUtils.defaultIfEmpty(builder.toString(), field
							+ " in ('')") + ") ";
			return result;
		}
		return null;
	}

	/**
	 * <b>function:</b> oracle sql not inӾУwhere id not in (1, 2, ...,
	 * 1000, 1001)Ӿг1000ͻᱨ ҪoracleơҪ⣬ where id
	 * (1, 2, ..., 1000) or id (1001, ...)
	 * 
	 * @createDate 2013-01-1502:36:03
	 * @param ids
	 *            not inеļ϶
	 * @param count
	 *            not inгֵ
	 * @param field
	 *            not inӦݿѯֶ
	 * @return  field in (...) or field in (...) ַ
	 */
	public static String getOracleSQLNOTIn(List<String> ids, int count,
			String field) {
		if (ids != null && ids.size() > 0) {
			count = Math.min(count, 1000);
			int len = ids.size();
			int size = len % count;
			if (size == 0) {
				size = len / count;
			} else {
				size = (len / count) + 1;
			}
			StringBuilder builder = new StringBuilder();
			for (int i = 0; i < size; i++) {
				int fromIndex = i * count;
				int toIndex = Math.min(fromIndex + count, len);
				String productId = StringUtils.defaultIfEmpty(StringUtils.join(
						ids.subList(fromIndex, toIndex).iterator(), "','"), "");
				if (i != 0) {
					builder.append(" and ");
				}
				builder.append(field).append(" not in ('").append(productId)
						.append("')");
			}
			String reusltStr = " ("
					+ StringUtils.defaultIfEmpty(builder.toString(), field
							+ " not in ('')") + ") ";
			return reusltStr;
		}
		return null;
	}

	/**
	 * @param pk_group
	 *            : ﴫ뼯
	 * @return ͨ룬ҵӦֵ
	 * 
	 */
	public static int getSalePoPricDigit(String pk_group) {
		int digit = ValueUtils.getInt(SysParaInitQuery.queryByParaCode(
				pk_group, "NC004").getValue());
		return digit;
	}

	/**
	 * @param pk_currtype
	 *            : 
	 * @return ͨȡñֶӦСλ add by gdt
	 * @throws BusinessException
	 */
	public static int getMnyDigitByCurrtype(String pk_currtype)
			throws BusinessException {
		ICurrtypeQuery ict = NCLocator.getInstance().lookup(
				ICurrtypeQuery.class);
		CurrtypeVO cvo = ict.findCurrtypeVOByPK(pk_currtype);
		return cvo.getCurrdigit();
	}

	/**
	 * @param pk_measdoc
	 *            : λ
	 * @return ͨλȡüλӦСλ add by gdt
	 * @throws BusinessException
	 */
	public static int getNumDigitByMeas(String pk_measdoc)
			throws BusinessException {
		IUAPQueryBS qbs = NCLocator.getInstance().lookup(IUAPQueryBS.class);
		MeasdocVO mvo = (MeasdocVO) qbs.retrieveByPK(MeasdocVO.class,
				pk_measdoc);
		return mvo.getBitnumber();
	}

	// public static UFDouble getRoundUFDouble(UFDouble value, int scal) {
	// return new UFDouble(value.doubleValue(), scal);
	// }

	/**
	 * 
	 * @param TimeType
	 * 
	 * @param 0:yyyy-MM-dd HH:mm:ss
	 * @param 1:yyyyMMddHHmmss
	 * @param 2yyyyMM
	 * @param 3:yyyy-MM-dd
	 * @param ĬΪ0
	 * @return صʱ
	 */
	public static String getNowTime(Integer TimeType, String strdate) {
		Date date = new Date();
		if (!isEmpty(strdate)) {
			date = getUFDate(strdate).toDate();
		}
		SimpleDateFormat from = null;
		switch (TimeType) {
		case 0:
			from = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
			break;
		case 1:
			from = new SimpleDateFormat("yyyyMMddHHmmss");
			break;
		case 2:
			from = new SimpleDateFormat("yyyyMM");
			break;
		case 3:
			from = new SimpleDateFormat("yyyy-MM-dd");
			break;
		default:
			from = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
			break;
		}
		return from.format(date);
	}

	public static String stringToAscii(String value) {
		StringBuffer sbu = new StringBuffer();
		char[] chars = value.toCharArray();
		for (int i = 0; i < chars.length; i++) {
			if (i != chars.length - 1) {
				sbu.append((int) chars[i]).append(",");
			} else {
				sbu.append((int) chars[i]);
			}
		}
		return sbu.toString();
	}

	public static String asciiToString(String value) {
		StringBuffer sbu = new StringBuffer();
		String[] chars = value.split(",");
		for (int i = 0; i < chars.length; i++) {
			sbu.append((char) Integer.parseInt(chars[i]));
		}
		return sbu.toString();
	}

	/**
	 * ȡǰϵͳʱ
	 * 
	 * @return
	 */
	public static String getSystemTime() {
		return new SimpleDateFormat("yyyy-MM-dd HH:mm:ss:SSS")
				.format(new Date());
	}

}